# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    The version of the OpenAPI document: 2020.03.10
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from allegro_api.configuration import Configuration


class Badge(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'offer': 'BadgeApplicationOffer',
        'campaign': 'OfferBadgeCampaign',
        'publication': 'BadgePublicationTimePolicy',
        'prices': 'BadgeApplicationPrices',
        'process': 'BadgeProcess'
    }

    attribute_map = {
        'offer': 'offer',
        'campaign': 'campaign',
        'publication': 'publication',
        'prices': 'prices',
        'process': 'process'
    }

    def __init__(self, offer=None, campaign=None, publication=None, prices=None, process=None, local_vars_configuration=None):  # noqa: E501
        """Badge - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._offer = None
        self._campaign = None
        self._publication = None
        self._prices = None
        self._process = None
        self.discriminator = None

        self.offer = offer
        self.campaign = campaign
        if publication is not None:
            self.publication = publication
        if prices is not None:
            self.prices = prices
        self.process = process

    @property
    def offer(self):
        """Gets the offer of this Badge.  # noqa: E501


        :return: The offer of this Badge.  # noqa: E501
        :rtype: BadgeApplicationOffer
        """
        return self._offer

    @offer.setter
    def offer(self, offer):
        """Sets the offer of this Badge.


        :param offer: The offer of this Badge.  # noqa: E501
        :type: BadgeApplicationOffer
        """
        if self.local_vars_configuration.client_side_validation and offer is None:  # noqa: E501
            raise ValueError("Invalid value for `offer`, must not be `None`")  # noqa: E501

        self._offer = offer

    @property
    def campaign(self):
        """Gets the campaign of this Badge.  # noqa: E501


        :return: The campaign of this Badge.  # noqa: E501
        :rtype: OfferBadgeCampaign
        """
        return self._campaign

    @campaign.setter
    def campaign(self, campaign):
        """Sets the campaign of this Badge.


        :param campaign: The campaign of this Badge.  # noqa: E501
        :type: OfferBadgeCampaign
        """
        if self.local_vars_configuration.client_side_validation and campaign is None:  # noqa: E501
            raise ValueError("Invalid value for `campaign`, must not be `None`")  # noqa: E501

        self._campaign = campaign

    @property
    def publication(self):
        """Gets the publication of this Badge.  # noqa: E501


        :return: The publication of this Badge.  # noqa: E501
        :rtype: BadgePublicationTimePolicy
        """
        return self._publication

    @publication.setter
    def publication(self, publication):
        """Sets the publication of this Badge.


        :param publication: The publication of this Badge.  # noqa: E501
        :type: BadgePublicationTimePolicy
        """

        self._publication = publication

    @property
    def prices(self):
        """Gets the prices of this Badge.  # noqa: E501


        :return: The prices of this Badge.  # noqa: E501
        :rtype: BadgeApplicationPrices
        """
        return self._prices

    @prices.setter
    def prices(self, prices):
        """Sets the prices of this Badge.


        :param prices: The prices of this Badge.  # noqa: E501
        :type: BadgeApplicationPrices
        """

        self._prices = prices

    @property
    def process(self):
        """Gets the process of this Badge.  # noqa: E501


        :return: The process of this Badge.  # noqa: E501
        :rtype: BadgeProcess
        """
        return self._process

    @process.setter
    def process(self, process):
        """Sets the process of this Badge.


        :param process: The process of this Badge.  # noqa: E501
        :type: BadgeProcess
        """
        if self.local_vars_configuration.client_side_validation and process is None:  # noqa: E501
            raise ValueError("Invalid value for `process`, must not be `None`")  # noqa: E501

        self._process = process

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Badge):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Badge):
            return True

        return self.to_dict() != other.to_dict()
