# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    The version of the OpenAPI document: 2020.03.10
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from allegro_api.configuration import Configuration


class BadgeProcess(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'status': 'str',
        'rejection_reasons': 'list[BadgeApplicationRejectionReason]'
    }

    attribute_map = {
        'status': 'status',
        'rejection_reasons': 'rejectionReasons'
    }

    def __init__(self, status=None, rejection_reasons=None, local_vars_configuration=None):  # noqa: E501
        """BadgeProcess - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._status = None
        self._rejection_reasons = None
        self.discriminator = None

        self.status = status
        self.rejection_reasons = rejection_reasons

    @property
    def status(self):
        """Gets the status of this BadgeProcess.  # noqa: E501


        :return: The status of this BadgeProcess.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this BadgeProcess.


        :param status: The status of this BadgeProcess.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and status is None:  # noqa: E501
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501
        allowed_values = ["IN_VERIFICATION", "WAITING_FOR_PUBLICATION", "ACTIVE", "FINISHED", "DECLINED"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and status not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def rejection_reasons(self):
        """Gets the rejection_reasons of this BadgeProcess.  # noqa: E501

        A list of messages with rejection reasons. Returned for process.status = DECLINED only.  # noqa: E501

        :return: The rejection_reasons of this BadgeProcess.  # noqa: E501
        :rtype: list[BadgeApplicationRejectionReason]
        """
        return self._rejection_reasons

    @rejection_reasons.setter
    def rejection_reasons(self, rejection_reasons):
        """Sets the rejection_reasons of this BadgeProcess.

        A list of messages with rejection reasons. Returned for process.status = DECLINED only.  # noqa: E501

        :param rejection_reasons: The rejection_reasons of this BadgeProcess.  # noqa: E501
        :type: list[BadgeApplicationRejectionReason]
        """
        if self.local_vars_configuration.client_side_validation and rejection_reasons is None:  # noqa: E501
            raise ValueError("Invalid value for `rejection_reasons`, must not be `None`")  # noqa: E501

        self._rejection_reasons = rejection_reasons

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BadgeProcess):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BadgeProcess):
            return True

        return self.to_dict() != other.to_dict()
