# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    The version of the OpenAPI document: 2020.03.10
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from allegro_api.configuration import Configuration


class CompatibilityListIdItemAllOf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'type': 'str',
        'id': 'str',
        'text': 'str',
        'additional_info': 'list[CompatibilityListIdItemAdditionalInfo]'
    }

    attribute_map = {
        'type': 'type',
        'id': 'id',
        'text': 'text',
        'additional_info': 'additionalInfo'
    }

    def __init__(self, type='ID', id=None, text=None, additional_info=None, local_vars_configuration=None):  # noqa: E501
        """CompatibilityListIdItemAllOf - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._type = None
        self._id = None
        self._text = None
        self._additional_info = None
        self.discriminator = None

        if type is not None:
            self.type = type
        self.id = id
        if text is not None:
            self.text = text
        if additional_info is not None:
            self.additional_info = additional_info

    @property
    def type(self):
        """Gets the type of this CompatibilityListIdItemAllOf.  # noqa: E501


        :return: The type of this CompatibilityListIdItemAllOf.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CompatibilityListIdItemAllOf.


        :param type: The type of this CompatibilityListIdItemAllOf.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def id(self):
        """Gets the id of this CompatibilityListIdItemAllOf.  # noqa: E501

        Id of the compatible item. Should be used in categories where ID version of compatible list is supported. See <a href=\"/documentation/#tag/Compatibility-List/paths/~1sale~1compatibility-list~1supported-categories/get\"> supported-categories</a> resource. <a href=\"../../compatibility_list\" target=\"_blank\">Read more</a>.  # noqa: E501

        :return: The id of this CompatibilityListIdItemAllOf.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CompatibilityListIdItemAllOf.

        Id of the compatible item. Should be used in categories where ID version of compatible list is supported. See <a href=\"/documentation/#tag/Compatibility-List/paths/~1sale~1compatibility-list~1supported-categories/get\"> supported-categories</a> resource. <a href=\"../../compatibility_list\" target=\"_blank\">Read more</a>.  # noqa: E501

        :param id: The id of this CompatibilityListIdItemAllOf.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def text(self):
        """Gets the text of this CompatibilityListIdItemAllOf.  # noqa: E501

        Text description of the compatible item. When creating (Post) or updating (Put) a compatibility list the field is ignored.  # noqa: E501

        :return: The text of this CompatibilityListIdItemAllOf.  # noqa: E501
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text):
        """Sets the text of this CompatibilityListIdItemAllOf.

        Text description of the compatible item. When creating (Post) or updating (Put) a compatibility list the field is ignored.  # noqa: E501

        :param text: The text of this CompatibilityListIdItemAllOf.  # noqa: E501
        :type: str
        """

        self._text = text

    @property
    def additional_info(self):
        """Gets the additional_info of this CompatibilityListIdItemAllOf.  # noqa: E501

        Details of the compatible item represented by ID.  # noqa: E501

        :return: The additional_info of this CompatibilityListIdItemAllOf.  # noqa: E501
        :rtype: list[CompatibilityListIdItemAdditionalInfo]
        """
        return self._additional_info

    @additional_info.setter
    def additional_info(self, additional_info):
        """Sets the additional_info of this CompatibilityListIdItemAllOf.

        Details of the compatible item represented by ID.  # noqa: E501

        :param additional_info: The additional_info of this CompatibilityListIdItemAllOf.  # noqa: E501
        :type: list[CompatibilityListIdItemAdditionalInfo]
        """

        self._additional_info = additional_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CompatibilityListIdItemAllOf):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CompatibilityListIdItemAllOf):
            return True

        return self.to_dict() != other.to_dict()
