# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    The version of the OpenAPI document: 2020.03.10
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from allegro_api.configuration import Configuration


class ConstraintCriteria(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'country': 'str',
        'type': 'str',
        'delivery_methods': 'list[JustId]'
    }

    attribute_map = {
        'country': 'country',
        'type': 'type',
        'delivery_methods': 'deliveryMethods'
    }

    def __init__(self, country=None, type=None, delivery_methods=None, local_vars_configuration=None):  # noqa: E501
        """ConstraintCriteria - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._country = None
        self._type = None
        self._delivery_methods = None
        self.discriminator = None

        if country is not None:
            self.country = country
        if type is not None:
            self.type = type
        if delivery_methods is not None:
            self.delivery_methods = delivery_methods

    @property
    def country(self):
        """Gets the country of this ConstraintCriteria.  # noqa: E501


        :return: The country of this ConstraintCriteria.  # noqa: E501
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """Sets the country of this ConstraintCriteria.


        :param country: The country of this ConstraintCriteria.  # noqa: E501
        :type: str
        """

        self._country = country

    @property
    def type(self):
        """Gets the type of this ConstraintCriteria.  # noqa: E501


        :return: The type of this ConstraintCriteria.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ConstraintCriteria.


        :param type: The type of this ConstraintCriteria.  # noqa: E501
        :type: str
        """
        allowed_values = ["COUNTRY_SAME_QUANTITY", "COUNTRY_DELIVERY_SAME_QUANTITY"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and type not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def delivery_methods(self):
        """Gets the delivery_methods of this ConstraintCriteria.  # noqa: E501


        :return: The delivery_methods of this ConstraintCriteria.  # noqa: E501
        :rtype: list[JustId]
        """
        return self._delivery_methods

    @delivery_methods.setter
    def delivery_methods(self, delivery_methods):
        """Sets the delivery_methods of this ConstraintCriteria.


        :param delivery_methods: The delivery_methods of this ConstraintCriteria.  # noqa: E501
        :type: list[JustId]
        """

        self._delivery_methods = delivery_methods

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConstraintCriteria):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ConstraintCriteria):
            return True

        return self.to_dict() != other.to_dict()
