# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    The version of the OpenAPI document: 2020.03.10
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from allegro_api.configuration import Configuration


class MessageRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'text': 'str',
        'attachment': 'DisputeAttachmentId',
        'type': 'str'
    }

    attribute_map = {
        'text': 'text',
        'attachment': 'attachment',
        'type': 'type'
    }

    def __init__(self, text=None, attachment=None, type=None, local_vars_configuration=None):  # noqa: E501
        """MessageRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._text = None
        self._attachment = None
        self._type = None
        self.discriminator = None

        self.text = text
        self.attachment = attachment
        self.type = type

    @property
    def text(self):
        """Gets the text of this MessageRequest.  # noqa: E501


        :return: The text of this MessageRequest.  # noqa: E501
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text):
        """Sets the text of this MessageRequest.


        :param text: The text of this MessageRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and text is None:  # noqa: E501
            raise ValueError("Invalid value for `text`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                text is not None and len(text) > 20000):
            raise ValueError("Invalid value for `text`, length must be less than or equal to `20000`")  # noqa: E501

        self._text = text

    @property
    def attachment(self):
        """Gets the attachment of this MessageRequest.  # noqa: E501


        :return: The attachment of this MessageRequest.  # noqa: E501
        :rtype: DisputeAttachmentId
        """
        return self._attachment

    @attachment.setter
    def attachment(self, attachment):
        """Sets the attachment of this MessageRequest.


        :param attachment: The attachment of this MessageRequest.  # noqa: E501
        :type: DisputeAttachmentId
        """
        if self.local_vars_configuration.client_side_validation and attachment is None:  # noqa: E501
            raise ValueError("Invalid value for `attachment`, must not be `None`")  # noqa: E501

        self._attachment = attachment

    @property
    def type(self):
        """Gets the type of this MessageRequest.  # noqa: E501


        :return: The type of this MessageRequest.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this MessageRequest.


        :param type: The type of this MessageRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["REGULAR", "END_REQUEST"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and type not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MessageRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MessageRequest):
            return True

        return self.to_dict() != other.to_dict()
