# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    The version of the OpenAPI document: 2020.03.10
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from allegro_api.configuration import Configuration


class OffersSearchResultDto(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'offers': 'list[OfferListingDto]',
        'count': 'int',
        'total_count': 'int'
    }

    attribute_map = {
        'offers': 'offers',
        'count': 'count',
        'total_count': 'totalCount'
    }

    def __init__(self, offers=None, count=None, total_count=None, local_vars_configuration=None):  # noqa: E501
        """OffersSearchResultDto - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._offers = None
        self._count = None
        self._total_count = None
        self.discriminator = None

        if offers is not None:
            self.offers = offers
        if count is not None:
            self.count = count
        if total_count is not None:
            self.total_count = total_count

    @property
    def offers(self):
        """Gets the offers of this OffersSearchResultDto.  # noqa: E501

        The list of seller's offers matching the request's criteria.  # noqa: E501

        :return: The offers of this OffersSearchResultDto.  # noqa: E501
        :rtype: list[OfferListingDto]
        """
        return self._offers

    @offers.setter
    def offers(self, offers):
        """Sets the offers of this OffersSearchResultDto.

        The list of seller's offers matching the request's criteria.  # noqa: E501

        :param offers: The offers of this OffersSearchResultDto.  # noqa: E501
        :type: list[OfferListingDto]
        """

        self._offers = offers

    @property
    def count(self):
        """Gets the count of this OffersSearchResultDto.  # noqa: E501

        Number of offers in the search result.  # noqa: E501

        :return: The count of this OffersSearchResultDto.  # noqa: E501
        :rtype: int
        """
        return self._count

    @count.setter
    def count(self, count):
        """Sets the count of this OffersSearchResultDto.

        Number of offers in the search result.  # noqa: E501

        :param count: The count of this OffersSearchResultDto.  # noqa: E501
        :type: int
        """

        self._count = count

    @property
    def total_count(self):
        """Gets the total_count of this OffersSearchResultDto.  # noqa: E501

        The total number of offers matching the request's criteria.  # noqa: E501

        :return: The total_count of this OffersSearchResultDto.  # noqa: E501
        :rtype: int
        """
        return self._total_count

    @total_count.setter
    def total_count(self, total_count):
        """Sets the total_count of this OffersSearchResultDto.

        The total number of offers matching the request's criteria.  # noqa: E501

        :param total_count: The total_count of this OffersSearchResultDto.  # noqa: E501
        :type: int
        """

        self._total_count = total_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OffersSearchResultDto):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OffersSearchResultDto):
            return True

        return self.to_dict() != other.to_dict()
