# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    The version of the OpenAPI document: 2020.03.10
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from allegro_api.configuration import Configuration


class VariantSetOffer(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'color_pattern': 'str'
    }

    attribute_map = {
        'id': 'id',
        'color_pattern': 'colorPattern'
    }

    def __init__(self, id=None, color_pattern=None, local_vars_configuration=None):  # noqa: E501
        """VariantSetOffer - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._color_pattern = None
        self.discriminator = None

        self.id = id
        if color_pattern is not None:
            self.color_pattern = color_pattern

    @property
    def id(self):
        """Gets the id of this VariantSetOffer.  # noqa: E501


        :return: The id of this VariantSetOffer.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VariantSetOffer.


        :param id: The id of this VariantSetOffer.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def color_pattern(self):
        """Gets the color_pattern of this VariantSetOffer.  # noqa: E501

        Label that allows to group variants via image. All variants having the same image should have identical identifier in this field.  # noqa: E501

        :return: The color_pattern of this VariantSetOffer.  # noqa: E501
        :rtype: str
        """
        return self._color_pattern

    @color_pattern.setter
    def color_pattern(self, color_pattern):
        """Sets the color_pattern of this VariantSetOffer.

        Label that allows to group variants via image. All variants having the same image should have identical identifier in this field.  # noqa: E501

        :param color_pattern: The color_pattern of this VariantSetOffer.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                color_pattern is not None and len(color_pattern) > 50):
            raise ValueError("Invalid value for `color_pattern`, length must be less than or equal to `50`")  # noqa: E501

        self._color_pattern = color_pattern

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VariantSetOffer):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, VariantSetOffer):
            return True

        return self.to_dict() != other.to_dict()
